#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include "prinhack.h"
#include "hacks.h"

char tileallowed[8][16];
int lpal[16];
palette_t palette[16];
int time, hp, checkpointlevel, checkpointdirection;
int respawnroom, respawnloc, roomclear, locclear;
int hplimit, startlevel, gtype[16];
char ghp[16], ltype[16];
int wdaenabled, minlevel, maxlevel;
char cp;
int guardtypeid[6] = {0, 1, 2, 3, 4, -1};

void togglewda(void)
{
	clrscr();
	wdaenabled ^= 1;
	if (wdaenabled)
	{
		printf("WDA enabled. Don't forget to update your\n");
		printf("vpalace.dat!\n");
		getch();
	}
	else
	{
		printf("WDA disabled.\n");
		getch();
	}
	misc();
}

char *env_str[2] = {"Dungeon", "Palace"};

void setenvironment(void)
{
	long i;
	char tempbuf[80];

	clrscr();
	for(i=0;i<16;i++)
	{
		if (curchoice == i) textcolor(WHITE+BLINK);
		else textcolor(WHITE);
		cprintf("Level %i, ", i);
		cprintf("%s", env_str[ltype[i]]);
		printf("\n");
	}
	textcolor(YELLOW);
	printf("\n");
	printf("Press , to go down.\n");
	printf("Press . to go up.\n");
	printf("Press Space to toggle environment\n");
	key = getch();
	switch(key)
	{
		case 44:
		curchoice--;
		if (curchoice < 0) curchoice = 0;
		setenvironment();
		break;
		case 46:
		curchoice++;
		if (curchoice > 15) curchoice = 15;
		setenvironment();
		break;
		case 32:
		ltype[curchoice] ^= 1;
		setenvironment();
		break;
		case 27:
		textcolor(WHITE);
		misc();
		break;
		default:
		setenvironment();
		break;
	}
}

void setghp(void)
{
	long i;
	char tempbuf[80];

	clrscr();
	for(i=0;i<16;i++)
	{
		if (curchoice == i) textcolor(WHITE+BLINK);
		else textcolor(WHITE);
		cprintf("Level %i, ", i);
		cprintf("HP: %d", ghp[i]);
		printf("\n");
	}
	textcolor(YELLOW);
	printf("\n");
	printf("Press , to go down.\n");
	printf("Press . to go up.\n");
	printf("Press - to decrease\n");
	printf("Press + to increase\n");
	key = getch();
	switch(key)
	{
		case 44:
		curchoice--;
		if (curchoice < 0) curchoice = 0;
		setghp();
		break;
		case 46:
		curchoice++;
		if (curchoice > 15) curchoice = 15;
		setghp();
		break;
		case 45:
		ghp[curchoice]--;
		if (ghp[curchoice] < 0) ghp[curchoice] = 0;
		setghp();
		break;
		case 61:
		case 43:
		ghp[curchoice]++;
		if (ghp[curchoice] > 10) ghp[curchoice] = 10;
		setghp();
		break;
		case 27:
		textcolor(WHITE);
		guards();
		break;
		default:
		setghp();
		break;
	}
}

char *guardstring[6] =
{
	"Default Guard (guard.dat)",
	"Fat Guard (fat.dat)",
	"Skeleton (skel.dat)",
	"Jaffar (vizier.dat)",
	"Shadow (shadow.dat)",
	"No guard, don't load resources"
};

void setgtype(void)
{
	long i;
	char tempbuf[80];

	clrscr();
	for(i=0;i<16;i++)
	{
		if (curchoice == i) textcolor(WHITE+BLINK);
		else textcolor(WHITE);
		cprintf("Level %i, ", i);
		cprintf("%s", guardstring[gtype[i]]);
		printf("\n");
	}
	textcolor(YELLOW);
	printf("\n");
	printf("Press , to go down.\n");
	printf("Press . to go up.\n");
	printf("Press -\\+ to switch types\n");
	key = getch();
	switch(key)
	{
		case 44:
		curchoice--;
		if (curchoice < 0) curchoice = 0;
		setgtype();
		break;
		case 46:
		curchoice++;
		if (curchoice > 15) curchoice = 15;
		setgtype();
		break;
		case 45:
		gtype[curchoice]--;
		if (gtype[curchoice] < 0) gtype[curchoice] = 0;
		setgtype();
		break;
		case 61:
		case 43:
		gtype[curchoice]++;
		if (gtype[curchoice] > 5) gtype[curchoice] = 5;
		setgtype();
		break;
		case 27:
		textcolor(WHITE);
		guards();
		break;
		default:
		setgtype();
		break;
	}
}

char *colorstring[16] =
{
	"Background",
	"Background 1",
	"Feather fall flashing",
	"Background 3",
	"Health or Life Flashing",
	"Background 5",
	"Background 6",
	"Stars in the princess room 1",
	"Stars in the princess room 2 and dialog show",
	"Bubbles of the blue potion",
	"Bubbles of the green potion",
	"backgroundb",
	"Losing life or die flashing",
	"backgroundd",
	"Getting sword flashing",
	"Font color"
};

int curpal;

void setcolors(void)
{
	long i;
	char tempbuf[80];

	clrscr();
	printf("%s\n",colorstring[curpal]);
	if (curchoice == 1) textcolor(WHITE+BLINK);
	else textcolor(WHITE);
	cprintf("R: %d", palette[curpal].r);
	printf("\n");
	if (curchoice == 2) textcolor(WHITE+BLINK);
	else textcolor(WHITE);
	cprintf("G: %d", palette[curpal].g);
	printf("\n");
	textcolor(YELLOW);
	if (curchoice == 3) textcolor(WHITE+BLINK);
	else textcolor(WHITE);
	cprintf("B: %d", palette[curpal].b);
	textcolor(WHITE);
	printf("\n");
	printf("\n");
	printf("Press [ to go to next palette\n");
	printf("Press ] to go to previous palette\n");
	printf("Press , to go down.\n");
	printf("Press . to go up.\n");
	printf("Press -\\+ to increase\\decrease values\n");
	key = getch();
	switch(key)
	{
		case 91:
		curpal--;
		if (curpal < 0) curpal = 0;
		setcolors();
		break;
		case 93:
		curpal++;
		if (curpal > 15) curpal = 15;
		setcolors();
		break;
		case 44:
		curchoice--;
		if (curchoice < 1) curchoice = 1;
		setcolors();
		break;
		case 46:
		curchoice++;
		if (curchoice > 3) curchoice = 3;
		setcolors();
		break;
		case 45:
		switch (curchoice)
		{
			case 1:
			if (palette[curpal].r > 0) palette[curpal].r--;
			break;
			case 2:
			if (palette[curpal].g > 0) palette[curpal].g--;
			break;
			case 3:
			if (palette[curpal].b > 0) palette[curpal].b--;
			break;
		}
		setcolors();
		break;
		case 61:
		case 43:
		switch (curchoice)
		{
			case 1:
			if (palette[curpal].r < 63) palette[curpal].r++;
			break;
			case 2:
			if (palette[curpal].g < 63) palette[curpal].g++;
			break;
			case 3:
			if (palette[curpal].b < 63) palette[curpal].b++;
			break;
		}
		setcolors();
		break;
		case 27:
		textcolor(WHITE);
		general();
		break;
		default:
		setcolors();
		break;
	}
}

void setcp(void)
{
	clrscr();
	printf("The potions level will appear before this level. Write -1 to disable.\n");
	printf("Level: ");
	scanf("%d", &cp);
	misc();
}

void setsavelevel(void)
{
	clrscr();
	printf("Minimal level where you can save (1-14)? ");
	scanf("%d", &minlevel);
	printf("Maximum level where you can save (1-14)? ");
	scanf("%d", &maxlevel);
	minlevel = minlevel-1;
	maxlevel = maxlevel+1;
	misc();
}

void starttimer(void)
{
	clrscr();
	printf("How much time do you want? ");
	scanf("%d", &time);
	general();
}

void setlevel(void)
{
	clrscr();
	printf("It will start here, even if you come back from the titles.\n");
	printf("Level number: ");
	scanf("%d", &startlevel);
	general();
}

void sethp(void)
{
	clrscr();
	printf("How much HP do you want to start with? ");
	scanf("%d", &hp);
	general();
}

void sethplimit(void)
{
	clrscr();
	printf("How much HP do you want to be limited to? ");
	scanf("%d", &hplimit);
	if (hplimit > 10)
	{
		printf("Warning: setting a value larger than 10 will cause the hit points display\n");
		printf("in the lower left corner of the screen to be overlapped by the\n");
		printf("remaining time messages, so it is discourages. However from the point\n");
		printf("of view of the game its value is handled correctly.\n");
		printf("Press any key\n");
		getch();
	}
	general();
}

char *tilestring[8] =
{
	"Lattice",
	"Skeleton",
	"Mirror",
	"Tapestry",
	"Big Pillar",
	"Chomper",
	"Spikes",
	"Big Window"
};

void settileallowed(void)
{
	long i, j, xpos, ypos;
	static int curcol = 0;
	
	clrscr();
	xpos = 12;
	ypos = 2;
	textcolor(WHITE);
	for(i=0;i<16;i++)
	{
		gotoxy((i*4)+12, 1);
		cprintf("%d", i);
	}
	printf("\n");
	for(i=0;i<8;i++) printf("%s\n", tilestring[i]);
	for(i=0;i<8;i++)
	{
		for(j=0;j<16;j++)
		{
			if (curchoice == j && curcol == i) textcolor(WHITE+BLINK);
			else textcolor(WHITE);
			gotoxy(xpos, ypos);
			if (tileallowed[i][j])
				cprintf("[X]");
			else
				cprintf("[ ]");
			xpos += 4;
		}
		xpos = 12;
		ypos++;
	}
	key = getch();
	if (key == 0)
	{
		key = getch();
		if (key == 77)
		{
			curchoice++;
			if (curchoice > 15)
			{
				if (curcol < 8) curcol++;
				curchoice = 0;
			}
		}
		else if (key == 75)
		{
			curchoice--;
			if (curchoice < 0)
			{
				if (curcol > 0) curcol--;
				curchoice = 15;
			}
		}
		else if (key == 72)
		{
			if (curcol > 0) curcol--;
			settileallowed();
		}
		else if (key == 80)
		{
			if (curcol < 8) curcol++;
			settileallowed();
		}
		key = 0;
	}
	switch (key)
	{
		case 27:
		general();
		break;
		case 32:
		tileallowed[curcol][curchoice] ^= 1;
		settileallowed();
		break;
		default:
		settileallowed();
		break;
	}
}

void setcheckpoint(void)
{
	clrscr();
	/*printf("When playing the original level 3, you must do a four tile jump\n");
	printf("to reach the second part of the level. Once the skeletion kills\n");
	printf("you, you'll be spawned on the second part of the level. But when\n");
	printf("you die, the whole level is reloaded to memory, this means that the\n");
	printf("loose tile that is in the four-tiled jump is not there anymore. The exe\n");
	printf("game erases this tile when you are spawned in the second part of the\n");
	printf("level to keep the map integrity. Other stuff like potions (especially \n");
	printf("the big one) are regenerated and you can drink them again. (yes this means\n");
	printf("that in level 3 you can have 2 big potions).\n");*/
	if (curchoice == 0) textcolor(WHITE+BLINK);
	else textcolor(WHITE);
	cprintf("Level: %d", checkpointlevel);
	printf("\n\n");
	if (curchoice == 1) textcolor(WHITE+BLINK);
	else textcolor(WHITE);
	cprintf("Where are you looking after respawning? ");
	if (checkpointdirection == -1) cprintf("Left");
	else cprintf("Right");
	printf("\n\n");
	if (curchoice == 2) textcolor(WHITE+BLINK);
	else textcolor(WHITE);
	cprintf("Respawn room: %d", respawnroom);
	textcolor(WHITE);
	printf("\nThis is not the checkpoint trigger, only the room where you appear,\nthe trigger is 'moving from room 7 to 2'\n\n");
	if (curchoice == 3) textcolor(WHITE+BLINK);
	else textcolor(WHITE);
	cprintf("Respawn location: %d", respawnloc);
	textcolor(WHITE);
	printf("\nA number from 0 to 29 indication tile and floor where you are\nrespawned. i.e 0 is top-left tile; 12 is middle, third from the left tile.\n\n");
	if (curchoice == 4) textcolor(WHITE+BLINK);
	else textcolor(WHITE);
	cprintf("Room of the tile to clear: %d", roomclear);
	textcolor(WHITE);
	printf("\nThis is the room where the tile is erased\n\n");
	if (curchoice == 5) textcolor(WHITE+BLINK);
	else textcolor(WHITE);
	cprintf("Location of the tile to clear: %d", locclear);
	textcolor(WHITE);
	printf("\nThe room tiles are from 0 to 29 in the same way as the location.\nRemember that you can erase potions, you can also set to an empty tile to do nothing.");
	key = getch();
	switch(key)
	{
		case 27:
		misc();
		break;
		case 45:
		switch (curchoice)
		{
			case 0:
			if (checkpointlevel > 0) checkpointlevel--;
			break;
			case 2:
			if (respawnroom > 0) respawnroom--;
			break;
			case 3:
			if (respawnloc > 0) respawnloc--;
			break;
			case 4:
			if (roomclear > 0) roomclear--;
			break;
			case 5:
			if (locclear > 0) locclear--;
			break;
		}
		setcheckpoint();
		break;
		case 61:
		case 43:
		switch (curchoice)
		{
			case 0:
			if (checkpointlevel < 15) checkpointlevel++;
			break;
			case 2:
			if (respawnroom < 24) respawnroom++;
			break;
			case 3:
			if (respawnloc < 29) respawnloc++;
			break;
			case 4:
			if (roomclear < 24) roomclear++;
			break;
			case 5:
			if (locclear < 29) locclear++;
			break;
		}
		setcheckpoint();
		break;
		case 32:
		if (curchoice == 1)
		{
			if (checkpointdirection == -1) checkpointdirection = 0;
			else checkpointdirection = -1;
		}
		setcheckpoint();
		break;
		case 0:
		key = getch();
		if (key == 72)
		{
			if (curchoice > 0) curchoice--;
		}
		if (key == 80)
		{
			if (curchoice < 5) curchoice++;
		}
		key = 0;
		setcheckpoint();
		break;
		default:
		setcheckpoint();
		break;
	}
}

void setlevelpalette(void)
{
	long i;
	char tempbuf[80];

	clrscr();
	for(i=0;i<16;i++)
	{
		if (curchoice == i) textcolor(WHITE+BLINK);
		else textcolor(WHITE);
		cprintf("Level %i, ", i);
		cprintf("Palette: %d", lpal[i]);
		printf("\n");
	}
	textcolor(YELLOW);
	printf("\n");
	printf("Press , to go down.\n");
	printf("Press . to go up.\n");
	printf("Press - to decrease\n");
	printf("Press + to increase\n");
	key = getch();
	switch(key)
	{
		case 44:
		curchoice--;
		if (curchoice < 0) curchoice = 0;
		setlevelpalette();
		break;
		case 46:
		curchoice++;
		if (curchoice > 15) curchoice = 15;
		setlevelpalette();
		break;
		case 45:
		lpal[curchoice]--;
		if (lpal[curchoice] < 0) lpal[curchoice] = 0;
		setlevelpalette();
		break;
		case 61:
		case 43:
		lpal[curchoice]++;
		if (lpal[curchoice] > 4) lpal[curchoice] = 4;
		setlevelpalette();
		break;
		case 27:
		textcolor(WHITE);
		misc();
		break;
		default:
		setlevelpalette();
		break;
	}
}
